Merge "Remove port from NEXUS_URL for netrc"
[releng/global-jjb.git] / .jjb-test / expected-xml / github-ciman-packer-verify
1 <?xml version="1.0" encoding="utf-8"?>
2 <project>
3   <actions/>
4   <description>&lt;!-- Managed by Jenkins Job Builder --&gt;</description>
5   <keepDependencies>false</keepDependencies>
6   <blockBuildWhenDownstreamBuilding>false</blockBuildWhenDownstreamBuilding>
7   <blockBuildWhenUpstreamBuilding>false</blockBuildWhenUpstreamBuilding>
8   <concurrentBuild>true</concurrentBuild>
9   <assignedNode>build-vm</assignedNode>
10   <canRoam>false</canRoam>
11   <properties>
12     <com.coravy.hudson.plugins.github.GithubProjectProperty>
13       <projectUrl>https://github.com/example-org/releng/ciman</projectUrl>
14     </com.coravy.hudson.plugins.github.GithubProjectProperty>
15     <hudson.model.ParametersDefinitionProperty>
16       <parameterDefinitions>
17         <hudson.model.StringParameterDefinition>
18           <name>PROJECT</name>
19           <description>Parameter to identify a Gerrit project. This is typically the
20 project repo path as exists in Gerrit.
21 For example: ofextensions/circuitsw
22 </description>
23           <defaultValue>releng/ciman</defaultValue>
24         </hudson.model.StringParameterDefinition>
25         <hudson.model.StringParameterDefinition>
26           <name>STREAM</name>
27           <description>Stream is often set to the same name as 'branch' but can
28 sometimes be used as a name representing a project's release code
29 name.
30 </description>
31           <defaultValue>master</defaultValue>
32         </hudson.model.StringParameterDefinition>
33         <hudson.model.StringParameterDefinition>
34           <name>GERRIT_PROJECT</name>
35           <description>Parameter to identify Gerrit project. This is typically the
36 project repo path as exists in Gerrit.
37 For example: ofextensions/circuitsw
38
39 Note that Gerrit will override this parameter automatically if a
40 job is triggered by Gerrit.
41 </description>
42           <defaultValue>releng/ciman</defaultValue>
43         </hudson.model.StringParameterDefinition>
44         <hudson.model.StringParameterDefinition>
45           <name>GERRIT_BRANCH</name>
46           <description>Parameter to identify a Gerrit branch.
47
48 Note that Gerrit will override this parameter automatically if a
49 job is triggered by Gerrit.
50 </description>
51           <defaultValue>master</defaultValue>
52         </hudson.model.StringParameterDefinition>
53         <hudson.model.StringParameterDefinition>
54           <name>GERRIT_REFSPEC</name>
55           <description>Parameter to identify a refspec when pulling from Gerrit.
56
57 Note that Gerrit will override this parameter automatically if a
58 job is triggered by Gerrit.
59 </description>
60           <defaultValue>refs/heads/master</defaultValue>
61         </hudson.model.StringParameterDefinition>
62         <hudson.model.StringParameterDefinition>
63           <name>LFTOOLS_VERSION</name>
64           <description>Version of lftools to install. Can be a specific version like
65 '0.6.0' or a PEP-440 definition.
66 https://www.python.org/dev/peps/pep-0440/
67 For example '&lt;1.0.0' or '&gt;=1.0.0,&lt;2.0.0'.
68 </description>
69           <defaultValue>&lt;1.0.0</defaultValue>
70         </hudson.model.StringParameterDefinition>
71         <hudson.model.StringParameterDefinition>
72           <name>PACKER_VERSION</name>
73           <description>Packer version to download and install.</description>
74           <defaultValue>1.1.1</defaultValue>
75         </hudson.model.StringParameterDefinition>
76       </parameterDefinitions>
77     </hudson.model.ParametersDefinitionProperty>
78   </properties>
79   <scm class="hudson.plugins.git.GitSCM">
80     <configVersion>2</configVersion>
81     <userRemoteConfigs>
82       <hudson.plugins.git.UserRemoteConfig>
83         <name>origin</name>
84         <refspec>+refs/pull/*:refs/remotes/origin/pr/*</refspec>
85         <url>git@github.com:example-org/releng/ciman</url>
86         <credentialsId>test-credential</credentialsId>
87       </hudson.plugins.git.UserRemoteConfig>
88     </userRemoteConfigs>
89     <branches>
90       <hudson.plugins.git.BranchSpec>
91         <name>**</name>
92       </hudson.plugins.git.BranchSpec>
93     </branches>
94     <excludedUsers/>
95     <buildChooser class="hudson.plugins.git.util.DefaultBuildChooser"/>
96     <doGenerateSubmoduleConfigurations>false</doGenerateSubmoduleConfigurations>
97     <authorOrCommitter>false</authorOrCommitter>
98     <wipeOutWorkspace>true</wipeOutWorkspace>
99     <pruneBranches>false</pruneBranches>
100     <remotePoll>false</remotePoll>
101     <gitTool>Default</gitTool>
102     <submoduleCfg class="list"/>
103     <relativeTargetDir/>
104     <reference/>
105     <gitConfigName/>
106     <gitConfigEmail/>
107     <skipTag>true</skipTag>
108     <scmName/>
109     <useShallowClone>false</useShallowClone>
110     <ignoreNotifyCommit>false</ignoreNotifyCommit>
111     <extensions>
112       <hudson.plugins.git.extensions.impl.SubmoduleOption>
113         <disableSubmodules>false</disableSubmodules>
114         <recursiveSubmodules>true</recursiveSubmodules>
115         <trackingSubmodules>false</trackingSubmodules>
116         <reference/>
117         <timeout>10</timeout>
118       </hudson.plugins.git.extensions.impl.SubmoduleOption>
119       <hudson.plugins.git.extensions.impl.WipeWorkspace/>
120     </extensions>
121   </scm>
122   <triggers class="vector">
123     <org.jenkinsci.plugins.ghprb.GhprbTrigger>
124       <spec/>
125       <adminlist/>
126       <allowMembersOfWhitelistedOrgsAsAdmin>false</allowMembersOfWhitelistedOrgsAsAdmin>
127       <whitelist/>
128       <orgslist/>
129       <cron/>
130       <triggerPhrase>^recheck$</triggerPhrase>
131       <onlyTriggerPhrase>false</onlyTriggerPhrase>
132       <useGitHubHooks>true</useGitHubHooks>
133       <permitAll>true</permitAll>
134       <autoCloseFailedPullRequests>false</autoCloseFailedPullRequests>
135       <extensions>
136         <org.jenkinsci.plugins.ghprb.extensions.status.GhprbSimpleStatus>
137           <commitStatusContext>Packer Verify</commitStatusContext>
138         </org.jenkinsci.plugins.ghprb.extensions.status.GhprbSimpleStatus>
139       </extensions>
140     </org.jenkinsci.plugins.ghprb.GhprbTrigger>
141   </triggers>
142   <builders>
143     <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
144       <managedFiles>
145         <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
146           <fileId>ci-packer-cloud-env</fileId>
147           <targetLocation/>
148           <variable>CLOUDENV</variable>
149         </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
150       </managedFiles>
151     </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
152     <EnvInjectBuilder>
153       <info>
154         <propertiesContent>PACKER_VERSION=1.1.1
155 </propertiesContent>
156       </info>
157     </EnvInjectBuilder>
158     <hudson.tasks.Shell>
159       <command>#!/bin/bash
160 # SPDX-License-Identifier: EPL-1.0
161 ##############################################################################
162 # Copyright (c) 2017 The Linux Foundation and others.
163 #
164 # All rights reserved. This program and the accompanying materials
165 # are made available under the terms of the Eclipse Public License v1.0
166 # which accompanies this distribution, and is available at
167 # http://www.eclipse.org/legal/epl-v10.html
168 ##############################################################################
169 echo &quot;---&gt; packer-install.sh&quot;
170 # The script checks for the packer binaries and installs the binary
171 # if its not available
172
173 # $PACKER_VERSION        : Define a packer version passed as job paramter
174
175 PACKER_VERSION=&quot;${PACKER_VERSION:-1.0.2}&quot;
176
177 # Ensure we fail the job if any steps fail.
178 set -eu -o pipefail
179
180 if hash packer.io 2&gt;/dev/null; then
181     echo &quot;packer.io command is available.&quot;
182 else
183     echo &quot;packer.io command not is available. Installing packer ...&quot;
184     # Installs Hashicorp's Packer binary, required for verify &amp; merge packer jobs
185     pushd packer
186     wget -nv &quot;https://releases.hashicorp.com/packer/${PACKER_VERSION}/packer_${PACKER_VERSION}_linux_amd64.zip&quot;
187     mkdir -p &quot;${WORKSPACE}/bin&quot;
188     unzip &quot;packer_${PACKER_VERSION}_linux_amd64.zip&quot; -d ${WORKSPACE}/bin/
189     # rename packer to avoid conflict with binary in cracklib
190     mv ${WORKSPACE}/bin/packer &quot;${WORKSPACE}/bin/packer.io&quot;
191     popd
192 fi
193
194 #!/bin/bash
195 # SPDX-License-Identifier: EPL-1.0
196 ##############################################################################
197 # Copyright (c) 2017 The Linux Foundation and others.
198 #
199 # All rights reserved. This program and the accompanying materials
200 # are made available under the terms of the Eclipse Public License v1.0
201 # which accompanies this distribution, and is available at
202 # http://www.eclipse.org/legal/epl-v10.html
203 ##############################################################################
204 echo &quot;---&gt; packer-validate.sh&quot;
205 # The script validates an packers files.
206
207 # $CLOUDENV            :  Provides the cloud credential file.
208
209 # Ensure we fail the job if any steps fail.
210 set -eu -o pipefail
211
212 PACKER_LOGS_DIR=&quot;$WORKSPACE/archives/packer&quot;
213 mkdir -p &quot;$PACKER_LOGS_DIR&quot;
214 export PATH=&quot;${WORKSPACE}/bin:$PATH&quot;
215
216 cd packer
217 varfiles=(../packer/vars/*.json)
218 templates=(../packer/templates/*.json)
219
220 for varfile in &quot;${varfiles[@]}&quot;; do
221     for template in &quot;${templates[@]}&quot;; do
222         export PACKER_LOG=&quot;yes&quot; &amp;&amp; \
223         export PACKER_LOG_PATH=&quot;$PACKER_LOGS_DIR/packer-validate-${varfile##*/}-${template##*/}.log&quot; &amp;&amp; \
224                     packer.io validate -var-file=&quot;$CLOUDENV&quot; \
225                     -var-file=&quot;$varfile&quot; &quot;$template&quot;
226         if [ $? -ne 0 ]; then
227             break
228         fi
229     done
230 done
231 </command>
232     </hudson.tasks.Shell>
233     <hudson.tasks.Shell>
234       <command>#!/bin/bash
235 # SPDX-License-Identifier: EPL-1.0
236 ##############################################################################
237 # Copyright (c) 2017 The Linux Foundation and others.
238 #
239 # All rights reserved. This program and the accompanying materials
240 # are made available under the terms of the Eclipse Public License v1.0
241 # which accompanies this distribution, and is available at
242 # http://www.eclipse.org/legal/epl-v10.html
243 ##############################################################################
244 echo &quot;---&gt; packer-clear-credentials.sh&quot;
245
246 set +e  # DO NOT cause build failure if any of the rm calls fail.
247 rm &quot;$CLOUDENV&quot;
248 exit 0
249 </command>
250     </hudson.tasks.Shell>
251   </builders>
252   <publishers>
253     <org.jenkinsci.plugins.postbuildscript.PostBuildScript>
254       <buildSteps>
255         <hudson.tasks.Shell>
256           <command>#!/bin/bash
257 # SPDX-License-Identifier: EPL-1.0
258 ##############################################################################
259 # Copyright (c) 2017 The Linux Foundation and others.
260 #
261 # All rights reserved. This program and the accompanying materials
262 # are made available under the terms of the Eclipse Public License v1.0
263 # which accompanies this distribution, and is available at
264 # http://www.eclipse.org/legal/epl-v10.html
265 ##############################################################################
266 echo &quot;---&gt; sysstat.sh&quot;
267 set +e  # DON'T fail build if script fails.
268
269 OS=$(facter operatingsystem)
270 case &quot;$OS&quot; in
271     Ubuntu)
272         SYSSTAT_PATH=&quot;/var/log/sysstat&quot;
273
274         # Dont run the script when systat is not enabled by default
275         if ! grep --quiet 'ENABLED=&quot;true&quot;' &quot;/etc/default/sysstat&quot;; then
276             exit 0
277         fi
278     ;;
279     CentOS|RedHat)
280         SYSSTAT_PATH=&quot;/var/log/sa&quot;
281     ;;
282     *)
283         # nothing to do
284         exit 0
285     ;;
286 esac
287
288 SAR_DIR=&quot;$WORKSPACE/archives/sar-reports&quot;
289 mkdir -p &quot;$SAR_DIR&quot;
290 cp &quot;$SYSSTAT_PATH/&quot;* &quot;$_&quot;
291 # convert sar data to ascii format
292 while IFS=&quot;&quot; read -r s
293 do
294     [ -f &quot;$s&quot; ] &amp;&amp; LC_TIME=POSIX sar -A -f &quot;$s&quot; &gt; &quot;$SAR_DIR/sar${s//[!0-9]/}&quot;
295 done &lt; &lt;(find &quot;$SYSSTAT_PATH&quot; -name &quot;sa[0-9]*&quot; || true)
296
297 # DON'T fail build if script fails.
298 exit 0
299 </command>
300         </hudson.tasks.Shell>
301         <org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep plugin="config-file-provider">
302           <managedFiles>
303             <org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
304               <fileId>jenkins-log-archives-settings</fileId>
305               <targetLocation/>
306               <variable>SETTINGS_FILE</variable>
307             </org.jenkinsci.plugins.configfiles.buildwrapper.ManagedFile>
308           </managedFiles>
309         </org.jenkinsci.plugins.configfiles.builder.ConfigFileBuildStep>
310         <EnvInjectBuilder>
311           <info>
312             <propertiesContent>SERVER_ID=logs</propertiesContent>
313           </info>
314         </EnvInjectBuilder>
315         <hudson.tasks.Shell>
316           <command>#!/bin/bash
317 # SPDX-License-Identifier: EPL-1.0
318 ##############################################################################
319 # Copyright (c) 2017 The Linux Foundation and others.
320 #
321 # All rights reserved. This program and the accompanying materials
322 # are made available under the terms of the Eclipse Public License v1.0
323 # which accompanies this distribution, and is available at
324 # http://www.eclipse.org/legal/epl-v10.html
325 ##############################################################################
326 echo &quot;---&gt; create-netrc.sh&quot;
327
328 # Ensure we fail the job if any steps fail.
329 set -eu -o pipefail
330
331 NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
332 CREDENTIAL=$(xmlstarlet sel -N &quot;x=http://maven.apache.org/SETTINGS/1.0.0&quot; \
333     -t -m &quot;/x:settings/x:servers/x:server[x:id='${SERVER_ID}']&quot; \
334     -v x:username -o &quot;:&quot; -v x:password \
335     &quot;$SETTINGS_FILE&quot;)
336
337 machine=$(echo &quot;$NEXUS_URL&quot; | awk -F/ '{print $3}')
338 user=$(echo &quot;$CREDENTIAL&quot; | cut -f1 -d:)
339 pass=$(echo &quot;$CREDENTIAL&quot; | cut -f2 -d:)
340
341 echo &quot;machine ${machine%:*} login $user password $pass&quot; &gt; ~/.netrc
342 </command>
343         </hudson.tasks.Shell>
344         <hudson.tasks.Shell>
345           <command>#!/bin/bash
346 # SPDX-License-Identifier: EPL-1.0
347 ##############################################################################
348 # Copyright (c) 2017 The Linux Foundation and others.
349 #
350 # All rights reserved. This program and the accompanying materials
351 # are made available under the terms of the Eclipse Public License v1.0
352 # which accompanies this distribution, and is available at
353 # http://www.eclipse.org/legal/epl-v10.html
354 ##############################################################################
355 echo &quot;---&gt; lftools-install.sh&quot;
356
357 # Script to install lftools via a version passed in via lf-infra-parameters
358 #
359 # Required parameters:
360 #
361 #     LFTOOLS_VERSION: Passed in via lf-infra-parameters configuration. Can be
362 #                      set to a strict version number like '1.2.3' or using
363 #                      PEP-440 definitions.
364 #
365 #                      Examples:
366 #                          &lt;1.0.0
367 #                          &gt;=1.0.0,&lt;2.0.0
368 #
369 # By default a released version of lftools should always be used.
370 # The purpose of the 2 variables below is so that lftools devs can test
371 # unreleased versions of lftools. There are 2 methods to install a dev version
372 # of lftools:
373 #
374 #     1) gerrit patch: Used to test a patch that has not yet been merged.
375 #                      To do this set something like this:
376 #                          LFTOOLS_MODE=gerrit
377 #                          LFTOOLS_REFSPEC=refs/changes/96/5296/7
378 #
379 #     2) git branch: Used to install an lftools version from a specific branch.
380 #                    To use this set the variables as follows:
381 #                          LFTOOLS_MODE=git
382 #                          LFTOOLS_REFSPEC=master
383 #
384 #     3) release : The intended use case and default setting.
385 #                  Set LFTOOLS_MODE=release, in this case LFTOOLS_REFSPEC is unused.
386
387 LFTOOLS_MODE=release  # release | git | gerrit
388 LFTOOLS_REFSPEC=master
389
390 # Ensure we fail the job if any steps fail.
391 # DO NOT set -u as virtualenv's activate script has unbound variables
392 set -e -o pipefail
393
394 virtualenv --quiet &quot;/tmp/v/lftools&quot;
395 # shellcheck source=/tmp/v/lftools/bin/activate disable=SC1091
396 source &quot;/tmp/v/lftools/bin/activate&quot;
397 pip install --quiet --upgrade pip
398
399 case $LFTOOLS_MODE in
400     gerrit)
401         git clone https://gerrit.linuxfoundation.org/infra/releng/lftools.git /tmp/lftools
402         pushd /tmp/lftools
403         git fetch origin &quot;$LFTOOLS_REFSPEC&quot;
404         git checkout FETCH_HEAD
405         pip install --quiet --upgrade -r requirements.txt
406         pip install --quiet --upgrade -e .
407         popd
408         ;;
409
410     git)
411         pip install --quiet --upgrade git+https://gerrit.linuxfoundation.org/infra/releng/lftools.git@&quot;$BRANCH&quot;
412         ;;
413
414     release)
415         if [[ $LFTOOLS_VERSION =~ ^[0-9] ]]; then
416             LFTOOLS_VERSION=&quot;==$LFTOOLS_VERSION&quot;
417         fi
418
419         pip install --quiet --upgrade &quot;lftools${LFTOOLS_VERSION}&quot;
420         ;;
421 esac
422
423 lftools --version
424
425 # pipdeptree prints out a lot of information because lftools pulls in many
426 # dependencies. Let's only print it if we want to debug.
427 # echo &quot;----&gt; Pip Dependency Tree&quot;
428 # pip install --quiet --upgrade pipdeptree
429 # pipdeptree
430
431 #!/bin/bash
432 # SPDX-License-Identifier: EPL-1.0
433 ##############################################################################
434 # Copyright (c) 2017 The Linux Foundation and others.
435 #
436 # All rights reserved. This program and the accompanying materials
437 # are made available under the terms of the Eclipse Public License v1.0
438 # which accompanies this distribution, and is available at
439 # http://www.eclipse.org/legal/epl-v10.html
440 ##############################################################################
441 echo &quot;---&gt; logs-deploy.sh&quot;
442
443 # Ensure we fail the job if any steps fail.
444 set -eu -o pipefail
445
446 set -x  # Trace commands for this script to make debugging easier.
447
448 ARCHIVE_ARTIFACTS=&quot;${ARCHIVE_ARTIFACTS:-}&quot;
449 LOGS_SERVER=&quot;${LOGS_SERVER:-None}&quot;
450
451 if [ &quot;${LOGS_SERVER}&quot; == 'None' ]
452 then
453     set +x # Disable trace since we no longer need it
454
455     echo &quot;WARNING: Logging server not set&quot;
456 else
457     NEXUS_URL=&quot;${NEXUSPROXY:-$NEXUS_URL}&quot;
458     NEXUS_PATH=&quot;${SILO}/${JENKINS_HOSTNAME}/${JOB_NAME}/${BUILD_NUMBER}&quot;
459     BUILD_URL=&quot;${BUILD_URL}&quot;
460
461     lftools deploy archives -p &quot;$ARCHIVE_ARTIFACTS&quot; &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$WORKSPACE&quot;
462     lftools deploy logs &quot;$NEXUS_URL&quot; &quot;$NEXUS_PATH&quot; &quot;$BUILD_URL&quot;
463
464     set +x  # Disable trace since we no longer need it.
465
466     echo &quot;Build logs: &lt;a href=\&quot;$LOGS_SERVER/$NEXUS_PATH\&quot;&gt;$LOGS_SERVER/$NEXUS_PATH&lt;/a&gt;&quot;
467 fi
468 </command>
469         </hudson.tasks.Shell>
470         <hudson.tasks.Shell>
471           <command>#!/bin/bash
472 # SPDX-License-Identifier: EPL-1.0
473 ##############################################################################
474 # Copyright (c) 2017 The Linux Foundation and others.
475 #
476 # All rights reserved. This program and the accompanying materials
477 # are made available under the terms of the Eclipse Public License v1.0
478 # which accompanies this distribution, and is available at
479 # http://www.eclipse.org/legal/epl-v10.html
480 ##############################################################################
481
482 # Clear log credential files
483 rm &quot;$SETTINGS_FILE&quot;
484 rm ~/.netrc
485 </command>
486         </hudson.tasks.Shell>
487         <hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
488           <regexp>^Build logs: .*</regexp>
489         </hudson.plugins.descriptionsetter.DescriptionSetterBuilder>
490       </buildSteps>
491       <scriptOnlyIfSuccess>false</scriptOnlyIfSuccess>
492       <scriptOnlyIfFailure>false</scriptOnlyIfFailure>
493       <markBuildUnstable>false</markBuildUnstable>
494     </org.jenkinsci.plugins.postbuildscript.PostBuildScript>
495     <hudson.plugins.ws__cleanup.WsCleanup plugin="ws-cleanup">
496       <patterns>
497         <hudson.plugins.ws__cleanup.Pattern>
498           <pattern>**/*.jenkins-trigger</pattern>
499           <type>EXCLUDE</type>
500         </hudson.plugins.ws__cleanup.Pattern>
501       </patterns>
502       <deleteDirs>false</deleteDirs>
503       <cleanupMatrixParent>false</cleanupMatrixParent>
504       <externalDelete/>
505       <cleanWhenSuccess>true</cleanWhenSuccess>
506       <cleanWhenUnstable>true</cleanWhenUnstable>
507       <cleanWhenFailure>true</cleanWhenFailure>
508       <cleanWhenNotBuilt>true</cleanWhenNotBuilt>
509       <cleanWhenAborted>true</cleanWhenAborted>
510       <notFailBuild>true</notFailBuild>
511     </hudson.plugins.ws__cleanup.WsCleanup>
512   </publishers>
513   <buildWrappers>
514     <com.michelin.cio.hudson.plugins.maskpasswords.MaskPasswordsBuildWrapper/>
515     <hudson.plugins.build__timeout.BuildTimeoutWrapper>
516       <timeoutMinutes>10</timeoutMinutes>
517       <timeoutEnvVar>BUILD_TIMEOUT</timeoutEnvVar>
518       <failBuild>true</failBuild>
519       <writingDescription>false</writingDescription>
520       <timeoutPercentage>0</timeoutPercentage>
521       <timeoutMinutesElasticDefault>3</timeoutMinutesElasticDefault>
522       <timeoutType>absolute</timeoutType>
523     </hudson.plugins.build__timeout.BuildTimeoutWrapper>
524     <hudson.plugins.timestamper.TimestamperBuildWrapper/>
525     <com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
526       <user>test-credential</user>
527     </com.cloudbees.jenkins.plugins.sshagent.SSHAgentBuildWrapper>
528     <jenkins.plugins.openstack.compute.JCloudsOneOffSlave/>
529   </buildWrappers>
530 </project>